# Copyright (c) 2010 BaseSoft B.V.
# See LICENSE for details.

from basesoft.web.contrib.dashboard.controllers import DashboardWidgetCQStateController
from django.utils.translation import ugettext_lazy as _
from basesoft.util.ordered_dict import OrderedDict

class WaveOverviewWidget(DashboardWidgetCQStateController):
    """
    Wave Overview Widget
    """
    label = _('Wave overview')
    name = 'tnt_clm_wave_overview_widget'
    icon = '16x16/categories/applications-accessories.png'
    category = 'CLM Management'
    permissions = ['tnt_clm_wave_manager']
    classname = 'palette_group__menu--manager'

class MailOverviewWidget(DashboardWidgetCQStateController):
    """
    Tnt Clm Mail Overview Widget
    """
    label = _('Mail overview')
    name = 'tnt_clm_mail_overview_widget'
    icon = '16x16/apps/internet-mail.png'
    category = 'CLM Management'
    permissions = ['view_tnt_wave_mail']
    classname = 'palette_group__menu--manager'

widgets_mapper = OrderedDict([
                 ('WaveOverviewWidget', WaveOverviewWidget),
                 ('MailOverviewWidget', MailOverviewWidget)
                 ])