# Copyright (c) 2011 BaseSoft B.V.
# See LICENSE for details.

from iqportal.tnt.clm.models import TntCLMWaveMail
from iqportal.tnt.clm.controllers import TntCLMMailBaseController, AbstractTntCLMMailStateController

class AbstractTntCLMWaveMailStateController(AbstractTntCLMMailStateController):

    # permissions needed for using this kind of mail
    CREATE_ACCESS_PERMISSIONS   = ['create_tnt_wave_mail']
    VIEW_ACCESS_PERMISSIONS     = ['view_tnt_wave_mail']
    UPDATE_ACCESS_PERMISSIONS   = ['update_tnt_wave_mail']
    DELETE_ACCESS_PERMISSIONS   = ['delete_tnt_wave_mail']
    SCHEDULE_ACCESS_PERMISSIONS = []


class TntCLMWaveMailMailStateController(AbstractTntCLMWaveMailStateController):
    _instance_class = TntCLMWaveMail

class MailController(TntCLMMailBaseController):
    """
    Class that's on top of TntCLMMailBaseController. This is used for
    handling Tnt CLM Mail objects.
    """

    # mapping between object type and the controller
    _state_controllers = {
        'TntCLMWaveMail': TntCLMWaveMailMailStateController,
    }
