from iqportal.tnt.report.configurable_widgets.abstract_tnt_widget import ConfigurableTntWidget

class CrossReferenceWidget(ConfigurableTntWidget):
    category = 'CLM Report'
    cube = 'TntCLMVirtualCube'
    datasource = 'TNT-CLM'
    label = 'Cross reference'

    def config(self):
        return {
    "category": "CLM",
    "show_hide_empty": True,
    "transposable": False,
    "dimensions": [
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": False,
            "caption": "Answer",
            "fancy_select_module": "clm_answer_fancy_select",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Answer].[Answer]",
                    "has_children_available": False,
                    "caption": "Answer",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Answer].[Answer]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": False,
            "caption": "AnswerFrom",
            "fancy_select_module": "clm_answer_fancy_select",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[AnswerFrom].[AnswerFrom]",
                    "has_children_available": False,
                    "caption": "AnswerFrom",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[AnswerFrom].[AnswerFrom]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Attribute",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": True,
            "children": [
                {
                    "unique_name": "[Attribute].[Type]",
                    "has_children_available": False,
                    "caption": "Type",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Attribute].[Type]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Attribute].[Attribute]",
                    "has_children_available": False,
                    "caption": "Attribute",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Attribute].[Attribute]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "AttributeFrom",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": True,
            "children": [
                {
                    "unique_name": "[AttributeFrom].[TypeFrom]",
                    "has_children_available": False,
                    "caption": "TypeFrom",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[AttributeFrom].[TypeFrom]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[AttributeFrom].[AttributeFrom]",
                    "has_children_available": False,
                    "caption": "AttributeFrom",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[AttributeFrom].[AttributeFrom]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": False,
            "caption": "KPI",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": True,
            "children": [
                {
                    "unique_name": "[KPI].[KPI]",
                    "has_children_available": False,
                    "caption": "KPI",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[KPI].[KPI]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": False,
            "caption": "KPIFrom",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": True,
            "children": [
                {
                    "unique_name": "[KPIFrom].[KPIFrom]",
                    "has_children_available": False,
                    "caption": "KPIFrom",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[KPIFrom].[KPIFrom]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Geolevel",
            "fancy_select_module": "level_filter_fancy_select",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Geolevel].[Business Unit]",
                    "has_children_available": True,
                    "caption": "Business Unit",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Geolevel].[Business Unit]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Geolevel].[Region]",
                    "has_children_available": True,
                    "caption": "Region",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Geolevel].[Region]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Geolevel].[Sub Region]",
                    "has_children_available": True,
                    "caption": "Sub Region",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Geolevel].[Sub Region]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Geolevel].[Country]",
                    "has_children_available": True,
                    "caption": "Country",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Geolevel].[Country]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Geolevel].[Depot]",
                    "has_children_available": True,
                    "caption": "Depot",
                    "has_all_member_available": False,
                    "show_members": False,
                    "method_argument": "[Geolevel].[Depot]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Location",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Location].[Location]",
                    "has_children_available": False,
                    "caption": "Location",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Location].[Location]",
                    "method": "get_level_members"
                }
            ]
        }, {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Respondent Type",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Respondent Type].[Respondent Type]",
                    "has_children_available": False,
                    "caption": "Respondent Type",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Respondent Type].[Respondent Type]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Revenue Band",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Revenue Band].[Revenue Band]",
                    "has_children_available": False,
                    "caption": "Revenue Band",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Revenue Band].[Revenue Band]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Service",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Service].[Service]",
                    "has_children_available": False,
                    "caption": "Service",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Service].[Service]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Wave",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Wave].[Main]",
                    "has_children_available": True,
                    "caption": "Main",
                    "has_all_member_available": True,
                    "show_members": True,
                    "method_argument": "[Wave].[Main]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Wave].[Code]",
                    "has_children_available": True,
                    "caption": "Code",
                    "has_all_member_available": True,
                    "show_members": True,
                    "method_argument": "[Wave].[Code]",
                    "method": "get_level_members"
                }
            ]
        }, {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Location 2015",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Location_2015].[Location_2015]",
                    "has_children_available": False,
                    "caption": "Location 2015",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Location_2015].[Location_2015]",
                    "method": "get_level_members"
                }
            ]
        }
    ],
    "reporter": "iqportal.tnt.report.CrossReferenceReporter",
    "datasource_id": 1,
    "label": "Cross reference",
    "cube": "TntCLMTrueResponseCube",
    "has_graph": True,
    "id": 15,
    "table_object_name": "tnt_graph_datatablecube",
    "table_module": "tnt_graph_datatablecube",
    "has_table": True,
    "show_excel_export": False,
    "graph_config": {
        "type": "stbar3d",
        "show_labels": True,
        "show_values": False,
    },
    'filter_panel_module': 'tnt_configurable_widget',
}

    def applied_filters(self):
        return {
            "axes_0": "columns",
            "axes_1": "rows",
            "axes_2": "columns",
            "axes_3": "rows",
            "axes_4": "",
            "axes_5": "",
            "axes_6": "",
            "axes_7": "",
            "axes_8": "",
            "axes_9": "",
            "axes_10": "",
            "axes_11": "",
            "axes_12": "",
            "show_table": True,
            "dimension_5": [],
            "dimension_2": [
                "[Attribute].[2].[36]"
            ],
            "dimension_3": [
                "[AttributeFrom].[2].[31]"
            ],
            "dimension_0": [
                "[Answer].[23]",
                "[Answer].[24]",
                "[Answer].[25]",
                "[Answer].[26]",
                "[Answer].[27]"
            ],
            "dimension_1": [
                "[AnswerFrom].[1]",
                "[AnswerFrom].[2]",
                "[AnswerFrom].[3]",
                "[AnswerFrom].[4]"
            ],
            "dimension_6": [],
            "dimension_7": [],
            "dimension_8": [],
            "dimension_9": [],
            "dimension_10": [],
            "dimension_4": [],
            "dimension_11": [],
            "dimension_12": [],
            "column_order": [
                "Attribute",
                "Answer"
            ],
            "row_order": [
                "AttributeFrom",
                "AnswerFrom"
            ],
            "dimensions": {
                "Service": "10",
                "Attribute": "2",
                "AttributeFrom": "3",
                "KPI": "4",
                "KPIFrom": "5",
                "Geolevel": "6",
                "AnswerFrom": "1",
                "Answer": "0",
                "Wave": "11",
                "Location": "7",
                "Location_2015": "12",
                "Respondent Type": "8",
                "Revenue Band": "9"
            },
            "kwargs": {"showSlicers": True}
        }
