from iqportal.tnt.report.configurable_widgets.abstract_tnt_widget import ConfigurableTntWidget

class DiffandAvgWidget(ConfigurableTntWidget):
    category = 'CLM Report'
    cube = 'TntCLMVirtualCube'
    datasource = 'TNT-CLM'

    def config(self):
        return {
            "category": "CLM",
            "show_hide_empty": True,
            "transposable": True,
            "reporter": "iqportal.tnt.report.DiffandAvgReporter",
            "label": "Diff and Avg",
            "cube": "TntCLMVirtualCube",
            "has_graph": False,
            "table_object_name": "tnt_graph_datatablecube",
            "table_module": "tnt_graph_datatablecube",
            "has_table": True,
            "show_excel_export": True,

            "has_drill_through": True,
            "has_drill_replace": True,
            "has_drill_position": True,

            "open_settings_on_drag": False,
            'filter_panel_module': 'tnt_configurable_widget',

            "dimensions": [
            {
                "available_on_rows": True,
                "show_named_sets": False,
                "has_select_as_group": True,
                "available_as_split_by": False,
                "required": False,
                "available_as_slicer": True,
                "caption": "Attribute",
                "fancy_select_module": "iq_fancyselect",
                "available_on_columns": True,
                "show_calculated_members": True,
                "children": [
                    {
                        "unique_name": "[Attribute].[Attribute]",
                        "has_children_available": False,
                        "caption": "Attribute",
                        "has_all_member_available": False,
                        "show_members": True,
                        "method_argument": "[Attribute].[Attribute]",
                        "method": "get_level_members"
                    }
                ]
            },

            {
                "available_on_rows": True,
                "show_named_sets": False,
                "has_select_as_group": False,
                "available_as_split_by": False,
                "required": False,
                "available_as_slicer": True,
                "caption": "KPI",
                "fancy_select_module": "iq_fancyselect",
                "available_on_columns": True,
                "show_calculated_members": True,
                "children": [
                    {
                        "unique_name": "[KPI].[KPI]",
                        "has_children_available": False,
                        "caption": "KPI",
                        "has_all_member_available": False,
                        "show_members": True,
                        "method_argument": "[KPI].[KPI]",
                        "method": "get_level_members"
                    }
                ]
            },

            {
                "available_on_rows": True,
                "show_named_sets": False,
                "has_select_as_group": False,
                "available_as_split_by": False,
                "required": False,
                "available_as_slicer": True,
                "caption": "Geolevel",
                "fancy_select_module": "level_filter_fancy_select",
                "available_on_columns": True,
                "show_calculated_members": False,
                "children": [
                    {
                        "unique_name": "[Geolevel].[Business Unit]",
                        "has_children_available": True,
                        "caption": "Business Unit",
                        "has_all_member_available": False,
                        "show_members": True,
                        "method_argument": "[Geolevel].[Business Unit]",
                        "method": "get_level_members"
                    },
                    {
                        "unique_name": "[Geolevel].[Region]",
                        "has_children_available": True,
                        "caption": "Region",
                        "has_all_member_available": False,
                        "show_members": True,
                        "method_argument": "[Geolevel].[Region]",
                        "method": "get_level_members"
                    },
                    {
                        "unique_name": "[Geolevel].[Sub Region]",
                        "has_children_available": True,
                        "caption": "Sub Region",
                        "has_all_member_available": False,
                        "show_members": True,
                        "method_argument": "[Geolevel].[Sub Region]",
                        "method": "get_level_members"
                    },
                    {
                        "unique_name": "[Geolevel].[Country]",
                        "has_children_available": True,
                        "caption": "Country",
                        "has_all_member_available": False,
                        "show_members": True,
                        "method_argument": "[Geolevel].[Country]",
                        "method": "get_level_members"
                    },
                    {
                        "unique_name": "[Geolevel].[Depot]",
                        "has_children_available": True,
                        "caption": "Depot",
                        "has_all_member_available": False,
                        "show_members": False,
                        "method_argument": "[Geolevel].[Depot]",
                        "method": "get_level_members"
                    }
                ]
            },
            {
                "available_on_rows": True,
                "show_named_sets": False,
                "has_select_as_group": False,
                "available_as_split_by": False,
                "required": False,
                "available_as_slicer": True,
                "caption": "Location",
                "fancy_select_module": "iq_fancyselect",
                "available_on_columns": True,
                "show_calculated_members": False,
                "children": [
                    {
                        "unique_name": "[Location].[Location]",
                        "has_children_available": True,
                        "caption": "Location",
                        "has_all_member_available": False,
                        "show_members": True,
                        "method_argument": "[Location].[Location]",
                        "method": "get_level_members"
                    }
                ]
            }, {
                "available_on_rows": True,
                "show_named_sets": False,
                "has_select_as_group": False,
                "available_as_split_by": False,
                "required": False,
                "available_as_slicer": True,
                "caption": "Respondent Type",
                "fancy_select_module": "iq_fancyselect",
                "available_on_columns": True,
                "show_calculated_members": False,
                "children": [
                    {
                        "unique_name": "[Respondent Type].[Respondent Type]",
                        "has_children_available": True,
                        "caption": "Respondent Type",
                        "has_all_member_available": False,
                        "show_members": True,
                        "method_argument": "[Respondent Type].[Respondent Type]",
                        "method": "get_level_members"
                    }
                ]
            },
            {
                "available_on_rows": True,
                "show_named_sets": False,
                "has_select_as_group": False,
                "available_as_split_by": False,
                "required": False,
                "available_as_slicer": True,
                "caption": "Revenue Band",
                "fancy_select_module": "iq_fancyselect",
                "available_on_columns": True,
                "show_calculated_members": False,
                "children": [
                    {
                        "unique_name": "[Revenue Band].[Revenue Band]",
                        "has_children_available": True,
                        "caption": "Revenue Band",
                        "has_all_member_available": False,
                        "show_members": True,
                        "method_argument": "[Revenue Band].[Revenue Band]",
                        "method": "get_level_members"
                    }
                ]
            },
            {
                "available_on_rows": True,
                "show_named_sets": False,
                "has_select_as_group": False,
                "available_as_split_by": False,
                "required": False,
                "available_as_slicer": True,
                "caption": "Service",
                "fancy_select_module": "iq_fancyselect",
                "available_on_columns": True,
                "show_calculated_members": False,
                "children": [
                    {
                        "unique_name": "[Service].[Service]",
                        "has_children_available": True,
                        "caption": "Service",
                        "has_all_member_available": False,
                        "show_members": True,
                        "method_argument": "[Service].[Service]",
                        "method": "get_level_members"
                    }
                ]
            },
            {
                "available_on_rows": True,
                "show_named_sets": False,
                "has_select_as_group": False,
                "available_as_split_by": False,
                "required": False,
                "available_as_slicer": True,
                "caption": "Wave",
                "fancy_select_module": "iq_fancyselect",
                "available_on_columns": True,
                "show_calculated_members": False,
                "children": [
                    {
                        "unique_name": "[Wave].[Main]",
                        "has_children_available": True,
                        "caption": "Main",
                        "has_all_member_available": False,
                        "show_members": True,
                        "method_argument": "[Wave].[Main]",
                        "method": "get_level_members"
                    },
                    {
                        "unique_name": "[Wave].[Code]",
                        "has_children_available": True,
                        "caption": "Code",
                        "has_all_member_available": False,
                        "show_members": True,
                        "method_argument": "[Wave].[Code]",
                        "method": "get_level_members"
                    }
                ]
            },

            {
                "available_on_rows": True,
                "show_named_sets": False,
                "has_select_as_group": False,
                "available_as_split_by": False,
                "required": False,
                "available_as_slicer": True,
                "caption": "P1",
                "fancy_select_module": "iq_fancyselect",
                "available_on_columns": True,
                "show_calculated_members": False,
                "children": [
                    {
                        "unique_name": "[P1].[P1]",
                        "has_children_available": False,
                        "caption": "P1",
                        "has_all_member_available": False,
                        "show_members": True,
                        "method_argument": "[P1].[P1]",
                        "method": "get_level_members"
                    }
                ]
            },

            {
                "available_on_rows": True,
                "show_named_sets": False,
                "has_select_as_group": False,
                "available_as_split_by": False,
                "required": False,
                "available_as_slicer": True,
                "caption": "Measure",
                "fancy_select_module": "iq_fancyselect",
                "available_on_columns": True,
                "show_calculated_members": False,
                "children": [
                    {
                        "unique_name": "[Measures].[MeasuresLevel]",
                        "has_children_available": False,
                        "caption": "MeasuresLevel",
                        "has_all_member_available": False,
                        "show_members": True,
                        "method_argument": "[Measures].[MeasuresLevel]",
                        "method": "get_level_members"
                    }
                ]
            }, {
                "available_on_rows": True,
                "show_named_sets": False,
                "has_select_as_group": False,
                "available_as_split_by": False,
                "required": False,
                "available_as_slicer": True,
                "caption": "Location 2015",
                "fancy_select_module": "iq_fancyselect",
                "available_on_columns": True,
                "show_calculated_members": False,
                "children": [
                    {
                        "unique_name": "[Location_2015].[Location_2015]",
                        "has_children_available": True,
                        "caption": "Location 2015",
                        "has_all_member_available": False,
                        "show_members": True,
                        "method_argument": "[Location_2015].[Location_2015]",
                        "method": "get_level_members"
                    }
                ]
            }
        ],
    }


    def applied_filters(self):
        return {

            "show_table": True,

            "hide_empty_fields": False,

            "dimensions": {
                "Attribute": "0",
                "KPI": "1",
                "Geolevel": "2",
                "Location": "3",
                "Location_2015": "10",
                "Respondent Type": "4",
                "Revenue Band": "5",
                "Service": "6",
                "Wave": "7",
                "P1": "8",
                "Measure": "9",
            },

            "axes_7": "columns",
            "axes_5": "",
            "axes_1": "slicers",
            "axes_10": "",

            "axes_0": "slicers",
            "axes_2": "rows",
            "axes_3": "",
            "axes_4": "",
            "axes_6": "slicers",
            "axes_9": "",
            "axes_8": "",

            "dimension_7": [
                "[Wave].[1].[2]",
                "[Wave].[1].[8]",
            ],

            "dimension_10": [],

            "dimension_8": [],

            "dimension_1": [
                "[KPI].[NCS Score]"
            ],

            "dimension_0": [
                "[Attribute].[Overall Satisfaction]"
            ],
            "dimension_2": [
                "[Geolevel].[Country].Members"
            ],
            "dimension_3": [],
            "dimension_4": [],
            "dimension_5": [],
            "dimension_6": [
                "[Service].[6]"
            ],
            "dimension_9": [],

            "column_order": [
                "Wave"
            ],
            "row_order": [
                "Geolevel"
            ],
            "slicer_order": [
                "KPI",
                "Measure",
            ],
            "kwargs": {"showSlicers": True}
        }
