from iqportal.tnt.report.configurable_widgets.abstract_tnt_widget import ConfigurableTntWidget

class GeneralAttributeGraphWidget(ConfigurableTntWidget):
    category = 'CLM Report'
    cube = 'TntCLMVirtualCube'
    datasource = 'TNT-CLM'
    label = "General Attribute (graph)"

    def config(self):
        return {
    "category": "CLM",
    "show_hide_empty": True,
    "transposable": False,
    "dimensions": [
        {
            "axis_depends_on": None,
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": True,
            "available_as_slicer": False,
            "caption": "Answer",
            "fancy_select_module": "clm_answer_fancy_select",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Answer].[Answer]",
                    "has_children_available": False,
                    "caption": "Answer",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Answer].[Answer]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "axis_depends_on": "Answer",
            "available_on_rows": False,
            "show_named_sets": False,
            "has_select_as_group": True,
            "available_as_split_by": False,
            "required": True,
            "available_as_slicer": False,
            "caption": "Attribute",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": False,
            "show_calculated_members": True,
            "children": [
                {
                    "unique_name": "[Attribute].[Type]",
                    "has_children_available": False,
                    "caption": "Type",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Attribute].[Type]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Attribute].[Attribute]",
                    "has_children_available": False,
                    "caption": "Attribute",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Attribute].[Attribute]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": False,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "KPIFrom",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": False,
            "show_calculated_members": True,
            "children": [
                {
                    "unique_name": "[KPIFrom].[KPIFrom]",
                    "has_children_available": False,
                    "caption": "KPIFrom",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[KPIFrom].[KPIFrom]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "axis_depends_on": None,
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Geolevel",
            "fancy_select_module": "level_filter_fancy_select",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Geolevel].[Business Unit]",
                    "has_children_available": True,
                    "caption": "Business Unit",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Geolevel].[Business Unit]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Geolevel].[Region]",
                    "has_children_available": True,
                    "caption": "Region",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Geolevel].[Region]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Geolevel].[Sub Region]",
                    "has_children_available": True,
                    "caption": "Sub Region",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Geolevel].[Sub Region]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Geolevel].[Country]",
                    "has_children_available": True,
                    "caption": "Country",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Geolevel].[Country]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Geolevel].[Depot]",
                    "has_children_available": True,
                    "caption": "Depot",
                    "has_all_member_available": False,
                    "show_members": False,
                    "method_argument": "[Geolevel].[Depot]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "axis_depends_on": None,
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Location",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Location].[Location]",
                    "has_children_available": False,
                    "caption": "Location",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Location].[Location]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "axis_depends_on": None,
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Respondent Type",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Respondent Type].[Respondent Type]",
                    "has_children_available": False,
                    "caption": "Respondent Type",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Respondent Type].[Respondent Type]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "axis_depends_on": None,
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Revenue Band",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Revenue Band].[Revenue Band]",
                    "has_children_available": False,
                    "caption": "Revenue Band",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Revenue Band].[Revenue Band]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "axis_depends_on": None,
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Service",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Service].[Service]",
                    "has_children_available": False,
                    "caption": "Service",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Service].[Service]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "axis_depends_on": None,
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Wave",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Wave].[Main]",
                    "has_children_available": False,
                    "caption": "Main",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Wave].[Main]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Wave].[Code]",
                    "has_children_available": True,
                    "caption": "Code",
                    "has_all_member_available": True,
                    "show_members": True,
                    "method_argument": "[Wave].[Code]",
                    "method": "get_level_members"
                }
            ]
        }, {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Location 2015",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Location_2015].[Location_2015]",
                    "has_children_available": False,
                    "caption": "Location 2015",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Location_2015].[Location_2015]",
                    "method": "get_level_members"
                }
            ]
        }
    ],
    "reporter": "iqportal.tnt.report.GAWidgetReporter",
    "datasource_id": 1,
    "label": "General Attribute (graph)",
    "show_excel_export": False,
    "cube": "TntCLMTrueResponseCube",
    "has_graph": True,
    "id": 9,
    "table_object_name": "tnt_graph_datatablecube",
    "table_module": "tnt_graph_datatablecube",
    "has_table": True,
    "graph_config": {
        "type": "pie3d",
        "show_labels": True,
        "show_values": False,
    },
    'filter_panel_module': 'tnt_configurable_widget',
}

    def applied_filters(self):
        return {
            "axes_0": "rows",
            "axes_1": "",
            "axes_2": "slicers",
            "axes_3": "",
            "axes_4": "",
            "axes_5": "",
            "axes_6": "",
            "axes_7": "",
            "axes_9": "",
            "axes_8": "columns",
            "show_table": False,
            "show_graph": True,

            "dimension_7": [],
            "dimension_3": [],
            "dimension_4": [],
            "dimension_5": [],
            "dimension_0": [
                "[Answer].[1]",
                "[Answer].[2]",
                "[Answer].[3]",
                "[Answer].[4]"
            ],
            "dimension_1": ["[Attribute].[Overall satisfaction]"],
            "dimension_2": [
                "[KPIFrom].[Satisfied]"
            ],
            "dimension_8": [
                "[Wave].[1].[2]"
            ],
            "dimension_6": [],
            "dimension_9": [],

            "column_order": [
                "Wave"
            ],
            "row_order": [
                "Answer"
            ],

            "dimensions": {
                "Respondent Type": "5",
                "Service": "7",
                "Attribute": "1",
                "KPIFrom": "2",
                "Geolevel": "3",
                "Location": "4",
                "Location_2015": "9",
                "Answer": "0",
                "Revenue Band": "6",
                "Wave": "8"
            },
            "kwargs": {"showSlicers": True}
        }
