'''
Created on Apr 17, 2012

@author: marten
'''

from iqportal.tnt.report.configurable_widgets.abstract_tnt_widget import ConfigurableTntWidget
from iqportal.iqube.core.models import DataSourceWidget

class GeneralAttributeWidget(ConfigurableTntWidget):
    category = 'CLM Report'
    cube = 'TntCLMVirtualCube'
    datasource = 'TNT-CLM'
    label = "General Attributes"

    def config(self):
        return {
    "category": "CLM",
    "show_hide_empty": True,
    "transposable": True,
    "dimensions": [
        {
            "axis_depends_on": None,
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": True,
            "available_as_slicer": False,
            "caption": "Answer",
            "fancy_select_module": "clm_answer_fancy_select",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Answer].[Answer]",
                    "has_children_available": True,
                    "caption": "Answer",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Answer].[Answer]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "axis_depends_on": None,
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": True,
            "available_as_split_by": False,
            "required": True,
            "available_as_slicer": True,
            "caption": "Attribute",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "filters": {
                "members": ["[Attribute].[2]", "[Attribute].[4]", "[Attribute].[6]", "SET [All General Attributes (Members)] AS 'ORDER({[Attribute].[2].Children,[Attribute].[4].Children,[Attribute].[6].Children}, [Attribute].[Attribute].CurrentMember.Caption, BASC)'"],
                "children": DataSourceWidget.FILTERS_CHILDREN_DIRECT_DESCENDANTS
            },
            "children": [
                {
                    "unique_name": "[Attribute].[Type]",
                    "has_children_available": True,
                    "caption": "Type",
                    "has_all_member_available": False,
                    "show_members": False,
                    "method_argument": "[Attribute].[Type]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Attribute].[Attribute]",
                    "has_children_available": False,
                    "caption": "Attribute",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Attribute].[Attribute]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "axis_depends_on": None,
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Geolevel",
            "fancy_select_module": "level_filter_fancy_select",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Geolevel].[Business Unit]",
                    "has_children_available": True,
                    "caption": "Business Unit",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Geolevel].[Business Unit]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Geolevel].[Region]",
                    "has_children_available": True,
                    "caption": "Region",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Geolevel].[Region]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Geolevel].[Sub Region]",
                    "has_children_available": True,
                    "caption": "Sub Region",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Geolevel].[Sub Region]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Geolevel].[Country]",
                    "has_children_available": True,
                    "caption": "Country",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Geolevel].[Country]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Geolevel].[Depot]",
                    "has_children_available": True,
                    "caption": "Depot",
                    "has_all_member_available": False,
                    "show_members": False,
                    "method_argument": "[Geolevel].[Depot]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "axis_depends_on": None,
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Location",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Location].[Location]",
                    "has_children_available": False,
                    "caption": "Location",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Location].[Location]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "axis_depends_on": None,
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Respondent Type",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Respondent Type].[Respondent Type]",
                    "has_children_available": False,
                    "caption": "Respondent Type",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Respondent Type].[Respondent Type]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "axis_depends_on": None,
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Revenue Band",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Revenue Band].[Revenue Band]",
                    "has_children_available": False,
                    "caption": "Revenue Band",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Revenue Band].[Revenue Band]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "axis_depends_on": None,
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Service",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Service].[Service]",
                    "has_children_available": False,
                    "caption": "Service",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Service].[Service]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "axis_depends_on": None,
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Wave",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Wave].[Main]",
                    "has_children_available": False,
                    "caption": "Main",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Wave].[Main]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Wave].[Code]",
                    "has_children_available": True,
                    "caption": "Code",
                    "has_all_member_available": True,
                    "show_members": True,
                    "method_argument": "[Wave].[Code]",
                    "method": "get_level_members"
                }
            ]
        }, {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Location 2015",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Location_2015].[Location_2015]",
                    "has_children_available": False,
                    "caption": "Location 2015",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Location_2015].[Location_2015]",
                    "method": "get_level_members"
                }
            ]
        }
    ],
    "reporter": "iqportal.tnt.report.GeneralAtttributesWidgetReporter",
    "datasource_id": 1,
    "label": "General Attribute (graph)",
    "show_excel_export": True,
    "cube": "TntCLMTrueResponseCube",
    "has_graph": True,
    "id": 9,
    "table_object_name": "tnt_graph_datatablecube",
    "table_module": "tnt_graph_datatablecube",
    "has_table": True,
    "graph_config": {
        "type": "pie3d",
        "show_values": False,
        "show_labels": True,
    },
    "open_settings_on_drag": False,
    'filter_panel_module': 'tnt_configurable_widget',

}

    def applied_filters(self):
        return {
            "axes_0": "rows",
            "axes_1": "rows",
            "axes_2": "",
            "axes_3": "",
            "axes_4": "",
            "axes_5": "",
            "axes_8": "",
            "axes_6": "slicers",
            "axes_7": "columns",
            "show_table": True,
            "dimension_8": [],
            "dimension_2": [],
            "dimension_3": [],
            "dimension_4": [],
            "dimension_0": [
                "[Answer].[Answer].Members"
            ],
            "dimension_1": ["SET [All General Attributes (Members)] AS 'ORDER({[Attribute].[2].Children,[Attribute].[4].Children,[Attribute].[6].Children}, [Attribute].[Attribute].CurrentMember.Caption, BASC)'"],
            "show_graph": False,
            "dimension_7": [
                "[Wave].[1].[2]"
            ],
            "dimension_5": [],
            "column_order": [
                "Wave"
            ],
            "row_order": [
                "Attribute",
                "Answer"
            ],
            "dimension_6": ["[Service].[6]"],
            "dimensions": {
                "Respondent Type": "4",
                "Service": "6",
                "Attribute": "1",
                "Geolevel": "2",
                "Location": "3",
                "Answer": "0",
                "Revenue Band": "5",
                "Wave": "7",
                "Location_2015": "8",
            },
            "kwargs": {"showSlicers": True},
            'display_graph_above_table': True
        }
