
from iqportal.tnt.report.configurable_widgets.abstract_tnt_widget import ConfigurableTntWidget

class LoyaltyLeagueTableNewWidget(ConfigurableTntWidget):
    category = 'CLM Report'
    cube = 'TntCLMVirtualCube'
    datasource = 'TNT-CLM'
    label = "Loyalty league table (New)"

    def config(self):
        return {
    "category": "CLM",
    "show_hide_empty": True,
    "transposable": True,
    "dimensions": [
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": False,
            "caption": "Answer",
            "fancy_select_module": "clm_answer_fancy_select",
            "available_on_columns": True,
            "show_calculated_members": True,
            "filters": {"members": ["[Answer].[1]", "[Answer].[2]", "[Answer].[3]", "[Answer].[4]"], "children": 0},
            "children": [
                {
                    "unique_name": "[Answer].[Answer]",
                    "has_children_available": False,
                    "caption": "Answer",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Answer].[Answer]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": True,
            "available_as_slicer": False,
            "caption": "Geolevel",
            "fancy_select_module": "level_filter_fancy_select",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Geolevel].[Business Unit]",
                    "has_children_available": True,
                    "caption": "Business Unit",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Geolevel].[Business Unit]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Geolevel].[Region]",
                    "has_children_available": True,
                    "caption": "Region",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Geolevel].[Region]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Geolevel].[Sub Region]",
                    "has_children_available": True,
                    "caption": "Sub Region",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Geolevel].[Sub Region]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Geolevel].[Country]",
                    "has_children_available": True,
                    "caption": "Country",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Geolevel].[Country]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Geolevel].[Depot]",
                    "has_children_available": True,
                    "caption": "Depot",
                    "has_all_member_available": False,
                    "show_members": False,
                    "method_argument": "[Geolevel].[Depot]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Location",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Location].[Location]",
                    "has_children_available": False,
                    "caption": "Location",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Location].[Location]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Respondent Type",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Respondent Type].[Respondent Type]",
                    "has_children_available": False,
                    "caption": "Respondent Type",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Respondent Type].[Respondent Type]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Revenue Band",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Revenue Band].[Revenue Band]",
                    "has_children_available": False,
                    "caption": "Revenue Band",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Revenue Band].[Revenue Band]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Service",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Service].[Service]",
                    "has_children_available": False,
                    "caption": "Service",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Service].[Service]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": True,
            "required": False,
            "available_as_slicer": True,
            "caption": "Wave",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Wave].[Main]",
                    "has_children_available": False,
                    "caption": "Main",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Wave].[Main]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Wave].[Code]",
                    "has_children_available": False,
                    "caption": "Code",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Wave].[Code]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "P1",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[P1].[P1]",
                    "has_children_available": False,
                    "caption": "P1",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[P1].[P1]",
                    "method": "get_level_members"
                }
            ]
        }, {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Location 2015",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Location_2015].[Location_2015]",
                    "has_children_available": False,
                    "caption": "Location 2015",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Location_2015].[Location_2015]",
                    "method": "get_level_members"
                }
            ]
        }
    ],
    "reporter": "iqportal.tnt.report.TntCLMLoyaltyLeagueTableWidgetReporter",
    "datasource_id": 1,
    "label": "Loyalty league table (New)",
    "cube": "TntCLMVirtualCube",
    "has_graph": False,
    "id": 11,
    "table_object_name": "tnt_graph_datatablecube",
    "table_module": "tnt_graph_datatablecube",
    "has_table": True,
    "show_excel_export": True,

    "has_drill_position": False,
    "open_settings_on_drag": False,
    'filter_panel_module': 'tnt_configurable_widget',

}

    def applied_filters(self):
        return {
            "axes_0": "columns",
            "axes_1": "rows",
            "axes_2": "",
            "axes_8": "",
            "axes_3": "",
            "axes_4": "",
            "axes_5": "slicers",
            "axes_6": "columns",
            "axes_7": "",
            "dimensions": {
                "Answer": "0",
                "Geolevel": "1",
                "Service": "5",
                "Wave": "6",
                "Location": "2",
                "Respondent Type": "3",
                "Revenue Band": "4",
                "P1": "7",
                "Location_2015": "8",
            },
            "show_table": True,
            "hide_empty_fields": True,
            "dimension_1": [
                "[Geolevel].[Country].Members"
            ],
            "dimension_2": [],
            "dimension_3": [],
            "dimension_4": [],
            "dimension_7": [],
            "dimension_8": [],
            "dimension_5": [
                "[Service].[6]"
            ],
            "dimension_0": [
                "[Answer].[Score %]"
            ],
            # see #2987
            "dimension_6": [
                "[Wave].[1].[2]", "[Wave].[1].[1]", "[Wave].[1].[6]", "[Wave].[1].[7]"
            ],
            "row_order": [
                "Geolevel"
            ],
            "column_order": [
                "Wave",
                "Answer"
            ],
            "kwargs": {"showSlicers": True}
        }
