'''
Created on 15 Feb 2012

@author: martijn
'''
from iqportal.tnt.report.configurable_widgets.abstract_tnt_widget import ConfigurableTntWidget

class RespondentsWidget(ConfigurableTntWidget):
    category = 'CLM Report'
    cube = 'TntCLMVirtualCube'
    datasource = 'TNT-CLM'
    label = 'Respondents Widget'

    def config(self):
        return {
    "category": "CLM",
    "show_hide_empty": True,
    "transposable": True,
    "dimensions": [
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": True,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Attribute",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": True,
            "children": [
                {
                    "unique_name": "[Attribute].[Attribute]",
                    "has_children_available": False,
                    "caption": "Attribute",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Attribute].[Attribute]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Answer",
            "fancy_select_module": "clm_answer_fancy_select",
            "available_on_columns": True,
            "show_calculated_members": True,
            "children": [
                {
                    "unique_name": "[Answer].[Answer]",
                    "has_children_available": False,
                    "caption": "Answer",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Answer].[Answer]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "KPI",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": True,
            "children": [
                {
                    "unique_name": "[KPI].[KPI]",
                    "has_children_available": False,
                    "caption": "KPI",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[KPI].[KPI]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": True,
            "available_as_slicer": False,
            "caption": "Geolevel",
            "fancy_select_module": "level_filter_fancy_select",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Geolevel].[Business Unit]",
                    "has_children_available": True,
                    "caption": "Business Unit",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Geolevel].[Business Unit]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Geolevel].[Region]",
                    "has_children_available": True,
                    "caption": "Region",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Geolevel].[Region]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Geolevel].[Sub Region]",
                    "has_children_available": True,
                    "caption": "Sub Region",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Geolevel].[Sub Region]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Geolevel].[Country]",
                    "has_children_available": True,
                    "caption": "Country",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Geolevel].[Country]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Geolevel].[Depot]",
                    "has_children_available": True,
                    "caption": "Depot",
                    "has_all_member_available": False,
                    "show_members": False,
                    "method_argument": "[Geolevel].[Depot]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Location",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Location].[Location]",
                    "has_children_available": True,
                    "caption": "Location",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Location].[Location]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Respondent Type",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Respondent Type].[Respondent Type]",
                    "has_children_available": True,
                    "caption": "Respondent Type",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Respondent Type].[Respondent Type]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Revenue Band",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Revenue Band].[Revenue Band]",
                    "has_children_available": True,
                    "caption": "Revenue Band",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Revenue Band].[Revenue Band]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Service",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Service].[Service]",
                    "has_children_available": True,
                    "caption": "Service",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Service].[Service]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": True,
            "required": False,
            "available_as_slicer": True,
            "caption": "Wave",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Wave].[Main]",
                    "has_children_available": False,
                    "caption": "Main",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Wave].[Main]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Wave].[Code]",
                    "has_children_available": False,
                    "caption": "Code",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Wave].[Code]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "P1",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[P1].[P1]",
                    "has_children_available": False,
                    "caption": "P1",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[P1].[P1]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Measures",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Measures].[MeasuresLevel]",
                    "has_children_available": False,
                    "caption": "MeasuresLevel",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Measures].[MeasuresLevel]",
                    "method": "get_level_members"
                }
            ]
        }, {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Location 2015",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Location_2015].[Location_2015]",
                    "has_children_available": True,
                    "caption": "Location 2015",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Location_2015].[Location_2015]",
                    "method": "get_level_members"
                }
            ]
        }
    ],
    "reporter": "iqportal.tnt.report.TntCLMDefaultConfigurableWidgetReporter",
    "has_drill_through": True,
    "datasource_id": 4,
    "label": "Respondents Widget",
    "show_excel_export": True,
    "has_drill_position": True,
    "cube": "TntCLMVirtualCube",
    "has_graph": False,
    "id": 9,
    "table_object_name": "tnt_graph_datatablecube",
    "table_module": "tnt_graph_datatablecube",
    "has_table": True,
    "graph_config": {},
    "has_drill_replace": True,
    "open_settings_on_drag": False,
    'filter_panel_module': 'tnt_configurable_widget',
}

    def applied_filters(self):
        return {
            "row_order": [
                "Geolevel"
            ],
            "show_table": True,
            "column_order": [
                "Wave"
            ],

            "slicer_order": [
                "Measure"
            ],

            "axes_0": "",
            "axes_1": "",
            "axes_2": "",
            "axes_3": "rows",
            "axes_4": "",
            "axes_5": "",
            "axes_6": "",
            "axes_7": "",
            "axes_8": "columns",
            "axes_9": "",
            "axes_10": "slicers",
            "axes_11": "",

            "dimensions": {
                "Attribute": "0",
                "Answer": "1",
                "KPI": "2",
                "Geolevel": "3",
                "Location": "4",
                "Location_2015": "11",
                "Respondent Type": "5",
                "Revenue Band": "6",
                "Service": "7",
                "Wave": "8",
                "P1": "9",
                "Measure": "10"
            },

            "dimension_6": [],
            "dimension_8": ["[Wave].[1].Children"],
            "dimension_2": [],
            "dimension_3": ["[Geolevel].[Country].Members"],
            "dimension_0": [],
            "dimension_1": [],
            "dimension_10": ["[Measures].[Respondents]"],
            "dimension_7": [],
            "dimension_4": [],
            "dimension_5": [],
            "dimension_11": [],
            "dimension_9": [],
            "kwargs": {"showSlicers": True}
        }
