from iqportal.tnt.report.configurable_widgets.abstract_tnt_widget import ConfigurableTntWidget

class NewSatisfactionTableWidget(ConfigurableTntWidget):
    category = 'CLM Report'
    cube = 'TntCLMVirtualCube'
    datasource = 'TNT-CLM'
    label = "Satisfaction Table (new)"

    def config(self):
        return {
    "category": "CLM",
    "show_hide_empty": True,
    "transposable": True,
    "dimensions": [
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": True,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Attribute",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": True,

            "has_drill_through": True,
            "has_drill_replace": True,
            "has_drill_position": True,

            "children": [
                {
                    "unique_name": "[Attribute].[Attribute]",
                    "has_children_available": False,
                    "caption": "Attribute",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Attribute].[Attribute]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "KPI",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": True,
            "children": [
                {
                    "unique_name": "[KPI].[KPI]",
                    "has_children_available": False,
                    "caption": "KPI",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[KPI].[KPI]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Geolevel",
            "fancy_select_module": "level_filter_fancy_select",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Geolevel].[Business Unit]",
                    "has_children_available": True,
                    "caption": "Business Unit",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Geolevel].[Business Unit]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Geolevel].[Region]",
                    "has_children_available": True,
                    "caption": "Region",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Geolevel].[Region]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Geolevel].[Sub Region]",
                    "has_children_available": True,
                    "caption": "Sub Region",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Geolevel].[Sub Region]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Geolevel].[Country]",
                    "has_children_available": True,
                    "caption": "Country",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Geolevel].[Country]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Geolevel].[Depot]",
                    "has_children_available": True,
                    "caption": "Depot",
                    "has_all_member_available": False,
                    "show_members": False,
                    "method_argument": "[Geolevel].[Depot]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": True,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Location",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Location].[Location]",
                    "has_children_available": False,
                    "caption": "Location",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Location].[Location]",
                    "method": "get_level_members"
                }
            ]
        }, {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": True,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Respondent Type",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Respondent Type].[Respondent Type]",
                    "has_children_available": False,
                    "caption": "Respondent Type",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Respondent Type].[Respondent Type]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": True,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Revenue Band",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Revenue Band].[Revenue Band]",
                    "has_children_available": False,
                    "caption": "Revenue Band",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Revenue Band].[Revenue Band]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": True,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Service",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Service].[Service]",
                    "has_children_available": False,
                    "caption": "Service",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Service].[Service]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": True,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Wave",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Wave].[Main]",
                    "has_children_available": False,
                    "caption": "Main",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Wave].[Main]",
                    "method": "get_level_members"
                },
                {
                    "unique_name": "[Wave].[Code]",
                    "has_children_available": False,
                    "caption": "Code",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Wave].[Code]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "P1",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[P1].[P1]",
                    "has_children_available": False,
                    "caption": "P1",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[P1].[P1]",
                    "method": "get_level_members"
                }
            ]
        },
        {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": False,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Measure",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Measures].[MeasuresLevel]",
                    "has_children_available": False,
                    "caption": "MeasuresLevel",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Measures].[MeasuresLevel]",
                    "method": "get_level_members"
                }
            ]
        }, {
            "available_on_rows": True,
            "show_named_sets": False,
            "has_select_as_group": True,
            "available_as_split_by": False,
            "required": False,
            "available_as_slicer": True,
            "caption": "Location 2015",
            "fancy_select_module": "iq_fancyselect",
            "available_on_columns": True,
            "show_calculated_members": False,
            "children": [
                {
                    "unique_name": "[Location_2015].[Location_2015]",
                    "has_children_available": False,
                    "caption": "Location 2015",
                    "has_all_member_available": False,
                    "show_members": True,
                    "method_argument": "[Location_2015].[Location_2015]",
                    "method": "get_level_members"
                }
            ]
        }
    ],
    "reporter": "iqportal.tnt.report.TntCLMDefaultConfigurableWidgetReporter",
    "datasource_id": 1,
    "label": "Satisfaction Table (new)",
    "show_excel_export": True,
    "cube": "TntCLMVirtualCube",
    "has_graph": False,
    "id": 12,
    "table_object_name": "tnt_graph_datatablecube",
    "table_module": "tnt_graph_datatablecube",
    "has_table": True,
    "has_calculated_member": True,
    "graph_config": {},
    "open_settings_on_drag": False,
    'filter_panel_module': 'tnt_configurable_widget',
}

    def applied_filters(self):
        return {
            "axes_0": "slicers",
            "axes_1": "columns",
            "axes_2": "",
            "axes_3": "",
            "axes_4": "",
            "axes_5": "",
            "axes_6": "slicers",
            "axes_7": "rows",
            "axes_8": "",
            "axes_9": "columns",
            "axes_10": "",

            "dimensions": {
                "KPI": "1",
                "Attribute": "0",
                "Geolevel": "2",
                "Location": "3",
                "Respondent Type": "4",
                "Revenue Band": "5",
                "Service": "6",
                "Wave": "7",
                "P1": "8",
                "Measure": "9",
                "Location_2015": "10",

            },
            "column_order": [
                "KPI"
            ],
            "row_order": [
                "Wave"
            ],
            "show_table": True,
            "dimension_2": [],
            "dimension_3": [],
            "dimension_0": [
                "[Attribute].[Overall satisfaction]"
            ],
            "dimension_1": [
                "[KPI].[No. of Answers]",
                "[KPI].[Dissatisfied %]",
                "[KPI].[Meeting Cust. Exp. %]",
                "[KPI].[Exceeding Cust. Exp. %]",
                "[KPI].[NCS Score]",
                "[KPI].[Mean Score]",
                "[KPI].[OES]"
            ],
            "dimension_6": [
                "[Service].[6]"
            ],
            "dimension_7": [
                "[Wave].[1].Children"
            ],
            "dimension_4": [],
            "dimension_5": [],
            "dimension_8": [],
            "dimension_9": [],
            "dimension_10": [],

            "kwargs": {"showSlicers": True}
        }

