# Copyright (c) 2011 BaseSoft B.V.
# See LICENSE for details.

from iqportal.tnt.report.controllers import TntWidgetStateController
from django.utils.translation import ugettext_lazy as _
from basesoft.util.ordered_dict import OrderedDict

class OverallSatisfactionWidget(TntWidgetStateController):
    """
    Overall Satisfaction Widget
    """
    label = _('Satisfaction (table)')
    name = 'db_overall_satisfaction_widget'
    icon = '16x16/categories/applications-accessories.png'
    category = 'CLM Report'
    permissions = ['view_wave_responses', 'view_datasource']
    classname = 'palette_group__menu--iqreport'

class OverallSatisfactionGraphsWidget(TntWidgetStateController):
    """
    Overall Satisfaction Widget
    """
    label = _('Satisfaction (graph)')
    name = 'db_overall_satisfaction_graphs_widget'
    icon = '16x16/categories/applications-accessories.png'
    category = 'CLM Report'
    permissions = ['view_wave_responses', 'view_datasource']
    classname = 'palette_group__menu--iqreport'

class LoyaltyScoreWidget(TntWidgetStateController):
    """
    Loyalty Core Widget
    """
    label = _('Loyalty score')
    name = 'db_loyalty_score_widget'
    icon = '16x16/categories/applications-accessories.png'
    category = 'CLM Report'
    permissions = ['view_wave_responses', 'view_datasource']
    classname = 'palette_group__menu--iqreport'

class ActionPlanningWidget(TntWidgetStateController):
    """
    Action Planning Widget
    """
    label = _('Action planning')
    name = 'db_action_planning_widget'
    icon = '16x16/categories/applications-accessories.png'
    category = 'CLM Report'
    permissions = ['view_wave_responses', 'view_datasource']
    classname = 'palette_group__menu--iqreport'

class NCSLeagueTableWidget(TntWidgetStateController):
    """
    NCS League Table Widget
    """
    label = _('League table (NCS)')
    name = 'db_ncs_league_table_widget'
    icon = '16x16/categories/applications-accessories.png'
    category = 'CLM Report'
    permissions = ['view_wave_responses', 'view_datasource']
    classname = 'palette_group__menu--iqreport'

class LoyaltyLeagueTableWidget(TntWidgetStateController):
    """
    Loyalty League Table Widget
    """
    label = _('League table (Loyalty)')
    name = 'db_loyalty_league_table_widget'
    icon = '16x16/categories/applications-accessories.png'
    category = 'CLM Report'
    permissions = ['view_wave_responses', 'view_datasource']
    classname = 'palette_group__menu--iqreport'

class StatisticalSignificanceWidget(TntWidgetStateController):
    """
    Statistical Significance Widget
    """
    label = _('Statistical significance')
    name = 'db_statistical_significance_widget'
    icon = '16x16/categories/applications-accessories.png'
    category = 'CLM Report'
    permissions = ['view_wave_responses', 'view_datasource']
    classname = 'palette_group__menu--iqreport'

class GeneralQuestionsWidget(TntWidgetStateController):

    label = _('General Questions')
    name = 'db_general_questions_widget'
    icon = '16x16/categories/applications-accessories.png'
    category = 'CLM Report'
    permissions = ['view_wave_responses', 'view_datasource']
    classname = 'palette_group__menu--iqreport'

widgets_mapper = OrderedDict([
                 ('OverallSatisfactionWidget', OverallSatisfactionWidget),
                 ('OverallSatisfactionGraphsWidget', OverallSatisfactionGraphsWidget),
                 ('LoyaltyScoreWidget', LoyaltyScoreWidget),
                 ('ActionPlanningWidget', ActionPlanningWidget),
                 ('NCSLeagueTableWidget', NCSLeagueTableWidget),
                 ('LoyaltyLeagueTableWidget', LoyaltyLeagueTableWidget),
                 #('StatisticalSignificanceWidget', StatisticalSignificanceWidget),
                 ('GeneralQuestionsWidget', GeneralQuestionsWidget)
                 ])
