# Copyright (c) 2011 BaseSoft B.V.
# See LICENSE for details.

from basesoft.web.contrib.dashboard.models import DashboardWidget

class TntCLMDashboardWidget(DashboardWidget):
    """
    Tnt specific dashboard widget
    @DynamicAttrs
    """
    def __repr__(self):
        return '<TntCLMDashboardWidget widget_id=%s>' % self.widget_id

class TntCLMDashboardWidgetFilter(object):
    """
    Tnt widgets filters
    @DynamicAttrs
    """

    FILTER_CATEGORY_ATTRIBUTES = 1
    FILTER_CATEGORY_WAVES = 2
    FILTER_CATEGORY_KPIS = 3
    FILTER_CATEGORY_GEOLEVELS = 4
    FILTER_CATEGORY_DEPOTS = 5
    FILTER_CATEGORY_SERVICES = 6
    FILTER_CATEGORY_REVENUE_BAND = 7
    FILTER_CATEGORY_LOCATION = 8
    FILTER_CATEGORY_RESPONDENT_TYPE = 9

    filter_categories = {
        FILTER_CATEGORY_ATTRIBUTES: 'attributes',
        FILTER_CATEGORY_WAVES: 'waves',
        FILTER_CATEGORY_KPIS: 'answers',
        FILTER_CATEGORY_GEOLEVELS: 'geolevels',
        FILTER_CATEGORY_DEPOTS: 'depots',
        FILTER_CATEGORY_SERVICES: 'services',
        FILTER_CATEGORY_REVENUE_BAND: 'revenue_band',
        FILTER_CATEGORY_LOCATION: 'location',
        FILTER_CATEGORY_RESPONDENT_TYPE: 'respondent_type',
    }

    def __repr__(self):
        return '<TntCLMDashboardWidgetFilter id=%s widget_id=%s>' % (self.id, self.widget_id)
