# Copyright (c) 2011 BaseSoft B.V.
# See LICENSE for details.

from iqportal.iqube.core.schedule import AbstractAggregateTask
from iqportal.tnt.report.controllers import TntOldResponseCubeAggregator,\
    TntTrueResponseCubeAggregator, TntResponseFullAggregator, TntCLMGeolevelHierarchyAggregator

from django.conf import settings

from basesoft import logging
from iqportal.iqube.core.controllers import DataSourceController
from basesoft.scheduler.crontab import CronTab
logger = logging.getLogger('iqportal.tnt.report.schedule')

class AggregateResponsesTask(AbstractAggregateTask):
    """
    re-populates and refreshes the tnt responses datasource
    """

    # every morning at 0700
    INTERVAL = CronTab('1 7 * * *')

    refresh_datasources = ('%s.TNT-CLM' % settings.SETTINGS_MODULE, )

    # disable auto clear_mondrian_cache when we clear cache ourselfs
    #clear_mondrian_cache = False

    def populate(self):

        data_modified = 0

        c = TntOldResponseCubeAggregator()
        self._aggregators.append(c)
        changed_old = c.run()

        c = TntResponseFullAggregator()
        self._aggregators.append(c)
        changed_full = c.run()

        c = TntTrueResponseCubeAggregator()
        self._aggregators.append(c)
        data_modified = data_modified + c.run()

        c = TntCLMGeolevelHierarchyAggregator()
        self._aggregators.append(c)
        changed_hier = data_modified + c.run()

        return changed_old or changed_full or changed_hier


tasks = (AggregateResponsesTask, )
