# Copyright (c) 2011 BaseSoft B.V.
# See LICENSE for details.

from basesoft.web.contrib.dashboard.controllers import DashboardWidgetStateController, DashboardWidgetCQStateController
from django.utils.translation import ugettext_lazy as _
from basesoft.util.ordered_dict import OrderedDict

class TntCLMRespondentsWidget(DashboardWidgetCQStateController):
    """
    TNT CLM Respondents Widget
    """
    label = _('Respondents chart')
    name = 'tnt_clm_respondents_widget'
    icon = '16x16/mimetypes/x-office-presentation-template.png'
    category = 'CLM Response'
    permissions = ['tnt_clm_wave_manager']
    classname = 'palette_group__menu--iqreport'

class TntCLMRespondentsOverviewWidget(DashboardWidgetCQStateController):
    """
    TNT CLM Respondents Widget
    """
    label = _('Respondents overview')
    name = 'tnt_clm_wave_respondents_overview_widget'
    icon = '16x16/apps/system-file-manager.png'
    category = 'CLM Response'
    permissions = ['tnt_clm_wave_manager']
    classname = 'palette_group__menu--manager'

class TntCLMRespondentsByCountryWidget(DashboardWidgetCQStateController):
    """
    TNT CLM Respondents Widget
    """
    label = _('Respondents by country')
    name = 'tnt_clm_wave_respondents_by_country_widget'
    icon = '16x16/apps/system-file-manager.png'
    category = 'CLM Response'
    permissions = ['tnt_clm_wave_manager']
    classname = 'palette_group__menu--manager'

class TntCLMPriorityExportStatusWidget(DashboardWidgetStateController):
    """
    Tnt CLM Priority Export status widget.
    """
    label = _('Priority export status')
    name = 'tnt_clm_priority_export_status_widget'
    icon = '16x16/apps/preferences-desktop-locale.png'
    category = 'CLM Response'
    permissions = ['tnt_clm_view_priority_export_status']
    classname = 'palette_group__menu--manager'

widgets_mapper = OrderedDict([
                 ('TntCLMRespondentsWidget', TntCLMRespondentsWidget),
                 ('TntCLMRespondentsOverviewWidget', TntCLMRespondentsOverviewWidget),
                 ('TntCLMRespondentsByCountryWidget', TntCLMRespondentsByCountryWidget),
                 ('TntCLMPriorityExportStatusWidget', TntCLMPriorityExportStatusWidget),
                 ])