# Copyright (c) 2010 BaseSoft B.V.
# See LICENSE for details.

from sqlalchemy.orm import interfaces

class TntSRQualityAuditResponseHook(interfaces.MapperExtension):

    def __calculate_score(self, instance):
        """
        Automatically calculate the scores for the different sections.
        """
        cp_score = sum([getattr(instance, 'customer_perspective_question%i' % i) for i in range(1, 7)])
        instance.customer_perspective_score = cp_score
        dcs = ['2_a', '2_b', '3_a', '3_b', '3_c', '3_d']
        dc_score = sum([getattr(instance, 'data_capture_question%s' % i) for i in dcs])
        instance.data_capture_score = dc_score
        instance.total_score = cp_score + dc_score

    def before_insert(self, mapper, connection, instance):
        """
        Insert calculated values.
        """
        self.__calculate_score(instance)

    def before_update(self, mapper, connection, instance):
        """
        Update calculated values.
        """
        self.__calculate_score(instance)
